%define with_postgres 1
%{?_without_postgres: %{expand: %%global with_postgres 0}}

%define with_mysql 1
%{?_without_mysql: %{expand: %%global with_mysql 0}}

%define with_odbc 1
%{?_without_odbc: %{expand: %%global with_odbc 0}}

%define with_sqlite 1
%{?_without_sqlite: %{expand: %%global with_sqlite 0}}

%define with_ibase 0
%{?_with_ibase: %{expand: %%global with_ibase 1}}

%define with_debug 0
%{?_with_debug: %{expand: %%global with_debug 1}}

%define enable_static 0
%{?_without_static: %{expand: %%global enable_static 0}}

%define with_cups 1
%{?_without_cups %{expand: %%global with_cups 0}}

%define libqt %mklibname qt 4
%define libqassistant %mklibname qassistant 1
%define libqtuitools %mklibname qtuitools 4
%define libqt3support %mklibname qt3support 4
%define libqtcore %mklibname qtcore 4
%define libqtdesigner %mklibname qtdesigner 1
%define libqtgui %mklibname qtgui 4
%define libqtnetwork %mklibname qtnetwork 4
%define libqtopengl %mklibname qtopengl 4
%define libqtsql %mklibname qtsql 4
%define libqtxml %mklibname qtxml 4
%define libqtsvg %mklibname qtsvg 4
%define libqttest %mklibname qttest 4

%define qtmajor 4
%define qtminor 1
%define qtsubminor 4

# KDE development version date
%define kde_copy 0
%define kde_qtcopy_date 20050928

%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define qtlib qt4
%define qtdir %_prefix/lib/%{qtlib}
%define pluginsdir %qtdir/plugins/%_lib

%if %{kde_copy}
%define qttarballdir qt-x11-free-%{qtversion}-kde-%{kde_qtcopy_date}
%else
%define qttarballdir qt-x11-opensource-src-%{qtversion}
%endif

Name: %{qtlib}
Version: %{qtversion}
Release: %mkrel 12
Epoch: 2
Summary: Qt GUI toolkit
Group: Development/KDE and Qt
License: GPL
URL: http://www.trolltech.com/
Source0: ftp://ftp.trolltech.com/qt/source/%{qttarballdir}.tar.bz2
# Not ready yet
#Source1: qt4.sh
#Source2: qt4.csh
Source3: qt4-designer-wrapper
Source4: qt4-designer.desktop
Source5: qt4.macros
Patch0: qt4-assistant-sharedlib.patch
Patch1: qt4-uitools-sharedlib.patch
BuildRequires: glibc-devel

%if %mdkversion <= 200600
BuildRequires: X11-devel
%if %{enable_static}
BuildRequires: X11-static-devel
%endif
%else
BuildRequires: libx11-devel
%if %{enable_static}
BuildRequires: libx11-static-devel
%endif
BuildRequires:  libxrandr-devel
%endif

BuildRequires: Mesa-common-devel
BuildRequires: zlib-devel 
BuildRequires: libpng-devel 
BuildRequires: libjpeg-devel
BuildRequires: libmng-devel
BuildRequires: lcms-devel
BuildRequires: cups-devel
BuildRequires: freetype2-devel
BuildRequires: libfontconfig-devel
BuildRequires: expat-devel
BuildRequires: perl
Provides: %{qtlib}
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications for the X
Window System. Qt is written in C++ and is fully object-oriented.

This package contains the shared library needed to run Qt
applications, as well as the README files for Qt.

#------------------------------------------------------------------------

%package common
Group: Development/KDE and Qt
Summary: config, language file for Qt

%description common
This package contains all config file and language file

%files common
%defattr(-,root,root,-)
%{_bindir}/qt4config
%{qtdir}/bin/qtconfig
%_sysconfdir/ld.so.conf.d/*
%dir %{qtdir}
%dir %{qtdir}/bin
%dir %{qtdir}/%_lib
%dir %pluginsdir
%dir %pluginsdir/sqldrivers
%{qtdir}/phrasebooks
%doc README

#------------------------------------------------------------------------
# CORE QT LIBRARIES
#-------------------------------------------------------------------------

%package -n %{libqtxml}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtxml}
QT%{qtmajor} component library

%post -n %{libqtxml} -p /sbin/ldconfig
%postun -n %{libqtxml} -p /sbin/ldconfig

%files -n %{libqtxml}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtXml.so.*
%{qtdir}/%_lib/libQtXml.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtXml_debug.so.*
%{qtdir}/%_lib/libQtXml_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtsql}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtsql}
QT%{qtmajor} component library

%post -n %{libqtsql} -p /sbin/ldconfig
%postun -n %{libqtsql} -p /sbin/ldconfig

%files -n %{libqtsql}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtSql.so.*
%{qtdir}/%_lib/libQtSql.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtSql_debug.so.*
%{qtdir}/%_lib/libQtSql_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtnetwork}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtnetwork}
QT%{qtmajor} component library

%post -n %{libqtnetwork} -p /sbin/ldconfig
%postun -n %{libqtnetwork} -p /sbin/ldconfig

%files -n %{libqtnetwork}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtNetwork.so.*
%{qtdir}/%_lib/libQtNetwork.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtNetwork_debug.so.*
%{qtdir}/%_lib/libQtNetwork_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtgui}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtgui}
QT%{qtmajor} component library

%post -n %{libqtgui} -p /sbin/ldconfig
%postun -n %{libqtgui} -p /sbin/ldconfig

%files -n %{libqtgui}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtGui.so.*
%{qtdir}/%_lib/libQtGui.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtGui_debug.so.*
%{qtdir}/%_lib/libQtGui_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtsvg}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtsvg}
QT%{qtmajor} component library

%post -n %{libqtsvg} -p /sbin/ldconfig
%postun -n %{libqtsvg} -p /sbin/ldconfig

%files -n %{libqtsvg}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtSvg.so.*
%{qtdir}/%_lib/libQtSvg.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtSvg_debug.so.*
%{qtdir}/%_lib/libQtSvg_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqttest}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqttest}
QT%{qtmajor} component library

%post -n %{libqttest} -p /sbin/ldconfig
%postun -n %{libqttest} -p /sbin/ldconfig

%files -n %{libqttest}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtTest.so.*
%{qtdir}/%_lib/libQtTest.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtTest_debug.so.*
%{qtdir}/%_lib/libQtTest_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtcore}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtcore}
QT%{qtmajor} component library

%post -n %{libqtcore} -p /sbin/ldconfig
%postun -n %{libqtcore} -p /sbin/ldconfig

%files -n %{libqtcore}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtCore.so.*
%{qtdir}/%_lib/libQtCore.prl
%pluginsdir/imageformats
%pluginsdir/inputmethods/libqimsw-multi.so
%if %{with_debug}
%{qtdir}/%_lib/libQtCore_debug.so.*
%{qtdir}/%_lib/libQtCore_debug.prl
%{qtdir}/%_lib/libQtUiTools.prl
%{qtdir}/%_lib/libQtUiTools_debug.prl
%pluginsdir/inputmethods/libqimsw-multi_debug.so
%endif

#-------------------------------------------------------------------------

%package -n %{libqt3support}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqt3support}
QT%{qtmajor} component library

%post -n %{libqt3support} -p /sbin/ldconfig
%postun -n %{libqt3support} -p /sbin/ldconfig

%files -n %{libqt3support}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQt3Support.so.*
%{qtdir}/%_lib/libQt3Support.prl
%pluginsdir/designer/libqt3supportwidgets.so
%if %{with_debug}
%{qtdir}/%_lib/libQt3Support_debug.so.*
%{qtdir}/%_lib/libQt3Support_debug.prl
%pluginsdir/designer/libqt3supportwidgets_debug.so
%endif

#-------------------------------------------------------------------------

%package -n %{libqtopengl}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtopengl}
QT%{qtmajor} component library

%post -n %{libqtopengl} -p /sbin/ldconfig
%postun -n %{libqtopengl} -p /sbin/ldconfig

%files -n %{libqtopengl}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtOpenGL.so.*
%{qtdir}/%_lib/libQtOpenGL.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtOpenGL_debug.so.*
%{qtdir}/%_lib/libQtOpenGL_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtdesigner}
Summary: QT%{qtmajor} component library
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtdesigner}
QT%{qtmajor} component library

%description -l pt_BR -n %{libqtdesigner}
Biblioteca componente da QT%{qtmajor}

%post -n %{libqtdesigner} -p /sbin/ldconfig
%postun -n %{libqtdesigner} -p /sbin/ldconfig

%files -n %{libqtdesigner}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtDesigner.so.*
%{qtdir}/%_lib/libQtDesigner.prl
%{qtdir}/%_lib/libQtDesignerComponents.so.*
%{qtdir}/%_lib/libQtDesignerComponents.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtDesign*_debug.so.*
%{qtdir}/%_lib/libQtDesign*_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqtuitools}
Summary: QT assistant lib
Summary(pt_BR): Biblioteca do qt-assistant
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqtuitools}
QT assistant lib

%post -n %{libqtuitools} -p /sbin/ldconfig
%postun -n %{libqtuitools} -p /sbin/ldconfig

%files -n %{libqtuitools}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtUiTools.so.*
%{qtdir}/%_lib/libQtUiTools.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtUiTools_debug.so.*
%{qtdir}/%_lib/libQtUiTools_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqassistant}
Summary: QT assistant lib
Summary(pt_BR): Biblioteca do qt-assistant
Group: System/Libraries
PreReq: %{name}-common = %epoch:%version

%description -n %{libqassistant}
QT assistant lib

%post -n %{libqassistant} -p /sbin/ldconfig
%postun -n %{libqassistant} -p /sbin/ldconfig

%files -n %{libqassistant}
%defattr(-,root,root,-)
%{qtdir}/%_lib/libQtAssistantClient.so.*
%{qtdir}/%_lib/libQtAssistantClient.prl
%if %{with_debug}
%{qtdir}/%_lib/libQtAssistantClient_debug.so.*
%{qtdir}/%_lib/libQtAssistantClient_debug.prl
%endif

#-------------------------------------------------------------------------

%package -n %{libqt}-devel
Summary: Development files and documentation for the Qt GUI toolkit.
Group: Development/KDE and Qt
Requires: %{name}-common = %epoch:%version
Provides: qt4-devel = %epoch:%version-%release
Provides: libqt4-devel = %epoch:%version-%release
# There's symlinks to devel
Requires: %{libqassistant} = %epoch:%version-%release
Requires: %{libqtuitools} = %epoch:%version-%release
Requires: %{libqt3support} = %epoch:%version-%release
Requires: %{libqtcore} = %epoch:%version-%release
Requires: %{libqtdesigner} = %epoch:%version-%release
Requires: %{libqtgui} = %epoch:%version-%release
Requires: %{libqtnetwork} = %epoch:%version-%release
Requires: %{libqtopengl} = %epoch:%version-%release
Requires: %{libqtsql} = %epoch:%version-%release
Requires: %{libqtxml} = %epoch:%version-%release
Requires: %{libqtsvg} = %epoch:%version-%release
Requires: %{libqttest} = %epoch:%version-%release


%description -n %{libqt}-devel
The %{qtlib}-devel package contains the files necessary to develop
applications using the Qt GUI toolkit: the header files, the Qt
meta object compiler, and the static libraries.  See the address
http://www.trolltech.com/products/qt.html for more information
about Qt.
Install qt-devel if you want to develop GUI applications using the Qt
toolkit.

%files -n %{libqt}-devel
%defattr(-,root,root,-)
%{qtdir}/bin/moc
%{qtdir}/bin/qmake
%{qtdir}/bin/uic
%{qtdir}/bin/uic3
%{qtdir}/bin/rcc
%{qtdir}/bin/qt3to4
%_sysconfdir/rpm/macros.d/*
%{qtdir}/include
%{qtdir}/mkspecs
%{qtdir}/%_lib/*.so
%{qtdir}/%_lib/*.la
%_prefix/%_lib/pkgconfig/*
%{qtdir}/q3porting.xml

#-------------------------------------------------------------------------

%if %{enable_static}
%package -n %{libqt}-static-devel
Summary: The static library for the Qt GUI toolkit
Group: System/Libraries

%description -n %{libqt}-static-devel
Qt is a GUI software toolkit which simplifies the task of writing and
maintaining GUI (Graphical User Interface) applications for the X
Window System. Qt is written in C++ and is fully object-oriented.

This package contains the shared library needed to run Qt
applications, as well as the README files for Qt.

%files -n %{libqt}-static-devel
%defattr(-,root,root,-)
%{qtdir}/%_lib/*.a

%endif

#-------------------------------------------------------------------------

%package doc
Summary: HTML Documentation for Qt version %{version}
Group: Documentation
Conflicts: %{name}-doc < %{qtversion}-1mdk

%description doc
HTML documentation for the Qt toolkit. To view the documentation,
please load up the file /usr/lib/%{qtlib}/doc/html/index.html in your
favourite browser.

%files doc
%defattr(-,root,root,-)
%{_docdir}/qt-%{qtversion}/html

#-------------------------------------------------------------------------

%package examples
Summary: Example programs made with Qt version %{version}
Group: Documentation

%description examples
Example programs made with Qt version %{version}.

%files examples
%defattr(-,root,root,-)
%{_docdir}/qt-%{qtversion}/examples
%{_docdir}/qt-%{qtversion}/demos
%exclude %{_docdir}/qt-%{qtversion}/examples/tutorial

#-------------------------------------------------------------------------

%package linguist
Summary: QT linguist translation utility
Group: Documentation
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

%description linguist
Qt Linguist provides easy translation of Qt GUIs to different
languages

%post linguist
%update_menus
%if %mdkversion > 200600
%{update_desktop_database}
%endif

%postun linguist
%clean_menus
%if %mdkversion > 200600
%{clean_desktop_database}
%endif

%files linguist
%defattr(-,root,root,-)
%{qtdir}/bin/linguist
%{qtdir}/bin/lrelease
%{qtdir}/bin/lupdate
%{qtdir}/bin/qm2ts
%_menudir/linguist
%if %mdkversion > 200600
%{_datadir}/applications/*linguist*.desktop
%endif

#-------------------------------------------------------------------------

%package assistant
Summary: QT assistantion doc utility
Group: Documentation
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

%description assistant
Qt Assistant provides a documentation Browser

%post assistant
%update_menus
%if %mdkversion > 200600
%{update_desktop_database}
%endif

%postun assistant
%clean_menus
%if %mdkversion > 200600
%{clean_desktop_database}
%endif

%files assistant
%defattr(-,root,root,-)
%{qtdir}/bin/assistant
%_menudir/assistant
%if %mdkversion > 200600
%{_datadir}/applications/*assistant*.desktop
%endif
#-------------------------------------------------------------------------

%package tutorial
Summary: Tutorial programs for Qt version %{version}
Group: Documentation

%description tutorial
Tutorial programs for Qt version %{version}.

%files tutorial
%defattr(-,root,root,-)
%{_docdir}/qt-%{qtversion}/examples/tutorial

#-------------------------------------------------------------------------

%if %{with_odbc}

%package database-plugin-odbc-%_lib
Summary: Database plugin for ODBC Qt support
Group: Development
Obsoletes: qt4-database-plugin-odbc
BuildRequires: unixODBC-devel

%description database-plugin-odbc-%_lib
Database plugin for ODBC Qt support

%files database-plugin-odbc-%_lib
%defattr(-,root,root,-)
%pluginsdir/sqldrivers/libqsqlodbc*

%endif

#-------------------------------------------------------------------------

%if %{with_mysql}

%package database-plugin-mysql-%_lib
Summary: Database plugin for mysql Qt support
Group: Development
Obsoletes: qt4-database-plugin-mysql
BuildRequires: libmysql-devel

%description database-plugin-mysql-%_lib
Database plugin for mysql Qt support

%files database-plugin-mysql-%_lib
%defattr(-,root,root,-)
%pluginsdir/sqldrivers/libqsqlmysql*

%endif

#-------------------------------------------------------------------------

%if %{with_sqlite}

%package database-plugin-sqlite-%_lib
Summary: Database plugin for sqlite Qt support
Group: Development
Obsoletes: qt4-database-plugin-sqlite
BuildRequires: sqlite3-devel
%if %{enable_static}
BuildRequires: sqlite3-static-devel
%endif

%description database-plugin-sqlite-%_lib
Database plugin for sqlite Qt support

%files database-plugin-sqlite-%_lib
%defattr(-,root,root,-)
%pluginsdir/sqldrivers/libqsqlite*
%endif

#-------------------------------------------------------------------------

%if %{with_ibase}

%package database-plugin-ibase-%_lib
Summary: Database plugin for interbase Qt support
Group: Development
Obsoletes: qt4-database-plugin-ibase
BuildRequires: firebird-devel

%description database-plugin-ibase-%_lib
Database plugin for interbase Qt support

%files database-plugin-ibase-%_lib
%defattr(-,root,root,-)
%pluginsdir/sqldrivers/libqsqlibase*
%endif

#-------------------------------------------------------------------------
%if %{with_postgres}

%package database-plugin-pgsql-%_lib
Summary: Database plugin for pgsql Qt support
Group: Development
Obsoletes: %name-database-plugin-pgsql
BuildRequires: postgresql-devel

%description database-plugin-pgsql-%_lib
Database plugin for pgsql Qt support

%files database-plugin-pgsql-%_lib
%defattr(-,root,root,-)
%pluginsdir/sqldrivers/libqsqlpsql*

%endif

#-------------------------------------------------------------------------

%package accessibility-plugin-%_lib
Summary: Accessibility plugins for Qt4
Group: Utilities
Obsoletes: %name-accessibility-plugin
Obsoletes: %name-accessibility-plugins

%description accessibility-plugin-%_lib
Acessibility plugins for Qt4

%files accessibility-plugin-%_lib
%defattr(-,root,root,-)
%dir %pluginsdir/accessible
%pluginsdir/accessible/*

#-------------------------------------------------------------------------

%package designer
Summary: %{qtlib} visual design tool
Group: Development
Requires: %{libqt}-devel = %epoch:%version

%description designer
The Qt Designer is a visual design tool that makes designing and
implementing user interfaces a lot easier.

%post designer
%update_menus

%postun designer
%clean_menus


%files designer
%defattr(-,root,root,-)
%{_bindir}/designer-qt%{qtmajor}
%{qtdir}/bin/designer
%{qtdir}/bin/designer-real
%if %mdkversion <= 200600
%_datadir/applnk/Development/designer4.desktop
%endif
%_menudir/%{libqt}-devel-designer
%if %mdkversion > 200600
%{_datadir}/applications/*designer*.desktop
%endif

#-------------------------------------------------------------------------

%prep
%if %{kde_copy}
%setup -q -n qt-copy
./apply_patches
%else
%setup -q -n %{qttarballdir}
%endif

%patch0 -p1 -b .assistshlib
%patch1 -p1 -b .uilib

%build
export QTDIR=`/bin/pwd`
export PATH=$QTDIR/bin:$PATH
export CFLAGS="${CFLAGS} %{optflags}"
export CXXFLAGS="${CXXFLAGS} %{optflags}"
export YACC='byacc -d'
%if %{kde_copy}
export LD_LIBRARY_PATH=%{_builddir}/qt-copy/lib:$LD_LIBRARY_PATH
export PATH=%{_builddir}/qt-copy/bin:$PATH
%else
export LD_LIBRARY_PATH=%{_builddir}/%{qttarballdir}/lib:$LD_LIBRARY_PATH
export PATH=%{_builddir}/%{qttarballdir}/bin:$PATH
%endif

#--------------------------------------------------------
# function configure
function qt_configure {

echo "yes" |
./configure \
	-prefix %{qtdir} \
%if %{with_debug}
   -debug-and-release \
%else
   -release \
%endif
   -sysconfdir %_sysconfdir \
   -libdir %{qtdir}/%_lib \
   -docdir %{_docdir}/qt-%{qtversion} \
   -plugindir %pluginsdir \
   -qt-gif \
%if ! %{with_cups}
   -no-cups \
%endif
   -no-exceptions \
   -L%_prefix/%_lib \
   -platform linux-g++ \
   -confirm-license \
   -verbose \
%if %mdkversion <= 200600   
   -I%_prefix/X11R6/include/ \
   -L%_prefix/X11R6/%_lib \
%endif   
	$*
}

# static
%if %{enable_static}
	qt_configure \
   %if %{with_sqlite}
   -qt-sql-sqlite \
   %endif
   -static

   make sub-src

	mkdir safelib
	cp lib/*.a safelib
%endif

# shared
qt_configure -shared \
   %if %{with_postgres}
   -plugin-sql-psql \
   -I%{_includedir}/pgsql \
   -I%{_includedir}/pgsql/server \
   %endif
   %if %{with_mysql}
   -plugin-sql-mysql \
   -I%{_includedir}/mysql \
   %else
   -no-sql-mysql \
   %endif
   %if %{with_ibase}
   -plugin-sql-ibase \
   %else
   -no-sql-ibase \
   %endif
   %if %{with_sqlite}
   -plugin-sql-sqlite \
   %else
   -no-sql-sqlite \
   %endif
   %if %{with_odbc}
   -plugin-sql-odbc
   %else
   -no-sql-odbc 
   %endif

make sub-src sub-tools

%install
rm -rf %buildroot
install -d %buildroot%{_bindir}
install -d %buildroot%{_docdir}/qt-%{qtversion}
install -d %buildroot%_sysconfdir
install -d %buildroot%_sysconfdir/profile.d
install -d %buildroot%_sysconfdir/ld.so.conf.d

#cp -f %{SOURCE1} %{SOURCE2} %buildroot%_sysconfdir/profile.d

make INSTALL_ROOT=%buildroot \
	sub-src-install_subtargets-ordered \
	sub-tools-install_subtargets-ordered \
	install_htmldocs \
	install_qmake \
	install_mkspecs

# Designer wrapper
pushd  %buildroot%{qtdir}/bin
mv designer designer-real
cp %{SOURCE3} designer
popd
ln -s %{qtdir}/bin/designer %buildroot%{_bindir}/designer-qt%{qtmajor}

# Desktop
%if %mdkversion <=200600
install -d -m 0755 %buildroot/%_datadir/applnk/Development/
install -m 0644 %SOURCE4 %buildroot/%_datadir/applnk/Development/designer4.desktop
%endif

install -d -m 0755 %buildroot/%_menudir
cat <<EOF > %buildroot/%_menudir/%{libqt}-devel-designer
?package(%{libqt}-devel): needs=X11 \
                        section="More Applications/Development/Development Environments" \
			title="Qt4 Designer" \
			longtitle="A graphical designer/dialog builder for Qt4" \
			command="/usr/bin/designer-qt4" \
			mimetypes="application/x-designer" \
			icon="development_environment_section.png" \
			xdg="true"
EOF

%if %mdkversion > 200600
mkdir $RPM_BUILD_ROOT%{_datadir}/applications
cat > $RPM_BUILD_ROOT%{_datadir}/applications/mandriva-designer-qt4.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=Qt4 Designer
Comment=A graphical designer/dialog builder for Qt4
Exec=/usr/bin/designer-qt4
Icon=development_environment_section.png
Terminal=false
Type=Application
StartupNotify=true
Categories=KDE;QT;Application;X-Mandrakelinux-MoreApplications-Development-DevelopmentEnvironments;
EOF
%endif

cat <<EOF > %buildroot/%_menudir/linguist
?package(qt4-linguist): needs=X11 \
                        section="More Applications/Development/Development Environments" \
			title="Qt Linguist" \
			longtitle="A translation tool for Qt4" \
			command="%qtdir/bin/linguist" \
			mimeType="application/x-linguist" \
			icon="development_environment_section.png" \
			xdg="true"
EOF

%if %mdkversion > 200600
cat > $RPM_BUILD_ROOT%{_datadir}/applications/mandriva-linguist-qt4.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=Qt Linguist
Comment=A translation tool for Qt4
Exec=%qtdir/bin/linguist
Icon=development_environment_section.png
Terminal=false
Type=Application
StartupNotify=true
MimeType=application/x-linguist
Categories=KDE;QT;Application;X-Mandrakelinux-MoreApplications-Development-DevelopmentEnvironments;
EOF
%endif


#Laurent rename binary program
cat <<EOF > %buildroot/%_menudir/assistant
?package(qt4-assistant): needs=X11 \
			section="More Applications/Documentation" \
			title="Qt4 Assistant" \
			longtitle="A manual browser for Qt4 documentation" \
			command="%{qtdir}/bin/assistant" \
			icon="documentation_section.png" \
			xdg="true"
EOF
%if %mdkversion > 200600
cat > $RPM_BUILD_ROOT%{_datadir}/applications/mandriva-assistant-qt4.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=Qt4 Assistant
Comment=A manual browser for Qt4 documentation
Exec=%{qtdir}/bin/assistant
Icon=documentation_section.png
Terminal=false
Type=Application
StartupNotify=true
Categories=KDE;QT;Application;X-Mandrakelinux-MoreApplications-Documentation;
EOF
%endif



# qtconfig
ln -s %{qtdir}/bin/qtconfig %buildroot%{_bindir}/qt4config

# Fix mkspec link
pushd  %buildroot%{qtdir}/mkspecs
rm -f default
ln -sf %{qtdir}/mkspecs/linux-g++ default
popd

#Copy examples/tutorial and demos
for subdir in examples demos; do
   for dir in `find $subdir -type d -name .obj`; do rm -rf $dir; done
   for dir in `find $subdir -type d -name .moc`; do rm -rf $dir; done
   cp -a $subdir %buildroot/%{_docdir}/qt-%{qtversion}
done

%if %{enable_static}
	cp safelib/* %buildroot/%{qtdir}/%_lib
%endif

# Use the new ld.so.conf.d 
pushd %buildroot/%_sysconfdir/ld.so.conf.d
echo "%{qtdir}/%_lib" > qt4.conf
popd

# Move pkgconfig for proper place
mkdir -p %buildroot/%_prefix/%_lib/pkgconfig
mv %buildroot/%{qtdir}/%_lib/*.pc %buildroot/%_prefix/%_lib/pkgconfig

# Fix all buildroot paths
find %buildroot/%qtdir/%_lib -type f -name '*prl' -exec perl -pi -e "s, -L%_builddir/\S+,,g" {} \;
find %buildroot/%qtdir/%_lib -type f -name '*prl' -exec sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" {} \;
find %buildroot/%qtdir/%_lib -type f -name '*la' -print -exec perl -pi -e "s, -L%_builddir/?\S+,,g" {} \;
find %buildroot/%_libdir/pkgconfig -type f -name '*pc' -print -exec perl -pi -e "s, -L%_builddir/?\S+,,g" {} \;
find %buildroot/%qtdir/mkspecs -name 'qmake.conf' -exec chmod -x -- {} \;
find %buildroot/%qtdir/mkspecs -name Info.plist.app -exec chmod -x -- {} \;

# Install rpm macros
mkdir -p %buildroot/%_sysconfdir/rpm/macros.d
install -m 0644 %SOURCE5 %buildroot/%_sysconfdir/rpm/macros.d

%clean
rm -rf %buildroot



%changelog
* Mon Aug 14 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-08-14 16:50:52 (56029)
- Qt 4.1.4 is stable, KDE 4 development use Qt 4.2 now, so we can drop debug
  packages to release in Mandriva 2007

* Mon Aug 14 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-08-14 15:41:40 (55994)
- Added qt4 rpm macros as same in qt3 package

* Fri Jul 21 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-07-21 16:35:07 (41888)
- qt4 doesn't support %%%%make

* Fri Jul 21 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-07-21 11:39:11 (41802)
- Fix menu on mdk <= 2006

* Thu Jun 29 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-29 13:22:58 (38164)
- Disable temporary compile static lib which breaks
  designer-qt4 until we fix it

* Wed Jun 28 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-28 09:00:44 (38113)
- Adapt patch from  cris at beebgames dot com to
  cleanup configure

* Fri Jun 23 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-23 11:46:29 (37917)
- 4.1.4

* Wed Jun 21 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-21 12:05:41 (37722)
- Use macro
  Rebuild

* Mon Jun 19 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-19 16:26:26 (37622)
- Rebuild qt4 with new libpng

* Tue Jun 06 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-06-06 18:16:48 (36706)
- remove Obsolete to fix upgrade

* Mon Jun 05 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-06-05 23:45:23 (36678)
- Increase release to recompile

* Wed May 31 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-31 22:12:58 (31821)
- Fix place of buildrequires (bug found by Boiko)

* Wed May 31 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-31 14:06:47 (31783)
- Add missing buildrequires

* Mon May 29 2006 Andreas Hasenack <andreas@mandriva.com>
+ 2006-05-29 14:36:37 (31646)
- renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

* Sat May 20 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-20 14:18:23 (27816)
- use %%%%make

* Sat May 20 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-20 13:05:35 (27814)
- This directory doesn't exit into 4.1.3 version

* Sat May 20 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-20 10:24:40 (27807)
- 4.1.3

* Wed May 17 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-17 00:00:45 (27475)
- Fix buildrequires

* Wed May 10 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-10 15:57:54 (27065)
- Adapt to new xdg menu

* Thu May 04 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-04 15:44:23 (26878)
- Qt4.1.2 doesn't support parallele compile :(

* Thu May 04 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-05-04 15:43:44 (26877)
- Fix compile when we unselect plugins.
  it's a bug into qt
  I send a bug report.

* Thu May 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-05-04 04:29:45 (26855)
- Fixed pkgconfig bad paths.

* Wed May 03 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-05-03 19:14:07 (26846)
- Devel package need requires for libraries to avoid broke symlinks

* Thu Apr 20 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-04-20 14:52:56 (26584)
- 4.1.2

* Wed Mar 08 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-08 01:04:09 (1879)
- qt4 is on main repository now. Shoud not compile against contrib packages. In
 this case, firebird is the one. My fault. :-(

* Sat Mar 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-04 16:24:42 (1861)
- Rearrange build requires.
- Add missing firebird-devel build requires for ibase plugin

* Sat Mar 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-04 14:05:36 (1859)
- Fix Provides, Requires and Obsoletes

* Sat Mar 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-04 03:57:02 (1858)
- QtUiTools have 4 as soname

* Sat Mar 04 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-03-04 03:40:29 (1857)
- Examples and demos now installed clean, without all build object files
 - Make plugins multi-arch enabled
 - Make uitools lib shared
 - Renamed accessibility and database plugins to match arch

* Mon Feb 27 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-02-27 15:57:13 (1815)
- Fix spec file

* Mon Feb 27 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-02-27 10:00:36 (1813)
- 4.1.1

* Tue Jan 17 2006 Laurent Montel <lmontel@mandriva.com>
+ 2006-01-17 08:30:19 (1434)
- Fix menuentry and generate them

* Thu Jan 12 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-01-12 01:17:07 (1411)
- Increase release
- Making _debug library packages by default on cooker release

* Thu Jan 12 2006 Helio Chissini de Castro <helio@mandriva.com>
+ 2006-01-12 01:07:51 (1410)
- Enabled acessibility plugin
- Added interbase database plugin package ( disabled by default )

* Tue Dec 20 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-12-20 16:46:31 (1320)
- Increment release version

* Tue Dec 20 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-12-20 15:05:36 (1319)
- 4.1.0 release

* Tue Nov 22 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-11-22 09:45:19 (1186)
- qt4.1.0-rc1

* Fri Oct 21 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-10-21 22:18:20 (1047)
- Finally a decent package with proper lib separation and fully working on x86_64
  archs
- 4.1 will take some time so already provided static libraries, as requested.
  It's suppose to be working, but since is first try, probably some features on
  static library could be not available like in shared ones , due to lack of
  static devel libs on Mandriva ( i.e. postgres, mysql, unixodbc, etc.. )
- Moved post install pkgconfig files to proper dir on system
- Fixed fontconfig,sqlite on x86_64

* Thu Sep 29 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-09-29 01:55:52 (967)
- Updated for 20050822 qt-copy with patches enabled
- Moved assistant for a separated package. This makes qt4-doc not depends of any
  binary package anymore
- Back release for a regular format, 1mdk.
- Fixed library placement on x86_64

* Mon Aug 22 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-08-22 19:39:57 (712)
- New upstream Qt 4.0.1 from kde-copy
- Applied kde-copy patches
- Removed separated debug packages. What seenn to be a good idea on the beggining makes bad since core
  will always made provides for both debug and release. so now just release is compiled, old _debug packages
  will be obsoleted and id compiled with debug, debug libs go with release libraries.

* Mon Aug 01 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-08-01 15:04:06 (489)
- Fix wronh version caused by a subversion conflict in spec

* Mon Aug 01 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-08-01 11:45:11 (483)
- Added current qt-copy snapshot
- Adopted Laurent solution for release, since this isn't an official 4.0.1 yet (
  my mess )
- Adopted Nick Brown request to add rpm build switch for mysql Reference:
  http://qa.mandriva.com/twiki/bin/view/Main/SpecfilesSwitch
- Fixed dependency bug for qtcore4-debug ( missing epoch )

* Fri Jul 29 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-07-29 15:12:59 (467)
- Changed to 4.0.0.1 since isn't 4.0.1 official
  Thanks to Thierry Vignaud

* Fri Jul 29 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-07-29 08:58:08 (463)
- Fix pkgconfig placement

* Fri Jul 29 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-07-29 06:43:43 (462)
- No parallel building

* Thu Jul 28 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-07-28 23:52:07 (460)
- Updated from qt-copy to 4.0.1 snapshot
- Splitted debug andregular libraries
- Added new pkgconfig files

* Wed Jul 06 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-07-06 08:56:56 (308)
- Compile with debug and not debug

* Tue Jul 05 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-07-05 10:25:37 (296)
- Fix menu

* Tue Jul 05 2005 Laurent Montel <lmontel@mandriva.com>
+ 2005-07-05 09:08:23 (294)
- Fix requires
  Remove requires on qt-devel which is defined into qt
  Add menu entry

* Thu Jun 30 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-06-30 14:21:48 (278)
- Again, missed point correct lib64 libraries

* Thu Jun 30 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-06-30 14:13:32 (277)
- fixed build requires for lib64

* Thu Jun 30 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-06-30 13:50:39 (276)
- Fixed lib64 lib placement

* Thu Jun 30 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-06-30 12:55:12 (275)
- Qt 4 GPL final release. ( Do the qt4dance :)
- Added desktop menu item for designer-qt4
- Based on qt-copy from KDE, updated by Simon Hausmann

* Thu Jun 16 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-06-16 08:21:27 (214)
- Updated new RC1 from qt-copy
- Renabled core libraries
- Still on debug mode

* Tue May 24 2005 Helio Chissini de Castro <helio@mandriva.com>
+ 2005-05-24 14:52:23 (8)
- Uploading package ./qt4
